@echo off
setlocal

echo Schneider Electric Data Center Expert USB Drive Preparation Script v1.0b (Windows)

if %1=="" goto SHOW_USAGE

set ISO_IMAGE=%1
set DRIVE_REMOVABLE=2

if not exist %ISO_IMAGE% goto ISO_NOT_EXIST

for %%A in ("%ISO_IMAGE%") do (
    set ISO_FILENAME=%%~nxA
)

net session >nul 2>&1 || goto NOTADMIN

set /p DriveName=Please enter the drive letter of your USB Flash key (ex. e:): 

rem deps\cmdline\GetDriveType %DriveName%
rem set DRIVE_TYPE=%errorlevel%

rem if not %DRIVE_TYPE%==%DRIVE_REMOVABLE% goto DRIVE_TYPE_ERROR

set /P FormatConfirm=Drive %DriveName% will be formatted, and all data will be lost.  Are you sure you want to continue? (y/n) 

if /I %FormatConfirm%==y goto FORMAT

if /I %FormatConfirm%==yes goto FORMAT

goto END

:FORMAT

format %DriveName% /X /Q /FS:FAT32 /V:ISXC /Y

if errorlevel 1 goto ERROR

echo Extracting ISO Image...
mkdir iso
deps\7-zip\7z x %ISO_IMAGE% -y -oiso ks.cfg isolinux\* >nul 2>&1

echo Copying files to %DriveName%...
mkdir %DriveName%\iso
mkdir %DriveName%\syslinux
echo Copying %ISO_IMAGE%...
copy /Z %ISO_IMAGE% %DriveName%\iso\
echo Copying initrd.img
copy /Z .\iso\isolinux\initrd.img %DriveName%\syslinux\
echo Copying vmlinuz
copy /Z .\iso\isolinux\vmlinuz %DriveName%\syslinux\
echo Copying boot.cat
copy .\iso\isolinux\boot.cat %DriveName%\syslinux\
echo Copying boot.msg
copy .\iso\isolinux\boot.msg %DriveName%\syslinux\
echo Copying splash.lss
copy .\iso\isolinux\splash.lss %DriveName%\syslinux\
.\deps\cmdline\sed s/cdrom/hd:LABEL=ISXC/ .\iso\isolinux\isolinux.cfg > %DriveName%\syslinux\syslinux.cfg
.\deps\cmdline\sed -e "0,/cdrom/s/cdrom/harddrive --partition=LABEL=ISXC --dir=\/iso\/%ISO_FILENAME%/" -e "s/^reboot.*/reboot/" -e "/^%%post/,/^%%end/ { /^%%end/ d }" .\iso\ks.cfg > .\ks.new
.\deps\cmdline\sed -e "$ a\ <br>chvt 1<br>echo -e \"\\a\" > /dev/tty1<br>echo -e \"\\n\\nSystem restore complete.\\n\\n\" > /dev/tty1<br>sleep 1<br>echo -e \"\\a\" > /dev/tty1<br>echo -e \"Press enter to reboot your StruxureWare Data Center Expert server.\\n\\nRemove your USB flash key when the system reboots.\\n\\n\" > /dev/tty1<br>read<br>echo -e \"System Rebooting...\" > /dev/tty1<br><br>%%end<br>" -e "/^%%post/ i %%post --nochroot --log=/mnt/sysimage/var/log/anaconda-post-nochroot.log<br>ls -l /run/install/repo<br>cp -r /run/install/repo/NetBotz/upgrade /mnt/sysimage/etc/nbc/<br>find /mnt/sysimage/etc/nbc/upgrade -iname \"TRANS.TBL\" -delete<br>%%end<br>" .\ks.new > .\ks.new2
.\deps\cmdline\sed -e "s/<br>/\n/g" -e "/^    # edit for automated/,/^    find \/etc/ { d }" -e "/^#clear screen/,/^fi/ { d }" .\ks.new2 > %DriveName%\ks.cfg
del .\ks.new
del .\ks.new2
.\deps\syslinux\syslinux -mfa %DriveName%

echo Cleaning up...
rmdir /s /q iso

:FINISH
echo Done!
goto END

:NOTADMIN
echo ERROR: You must run this script with administrator privileges
goto END

:ISO_NOT_EXIST
echo ERROR: The specified .iso image does not exist
pause
goto END

:DRIVE_TYPE_ERROR
echo ERROR: The specified drive is not a removable drive
pause
goto END

:ERROR
echo An error was encountered.
pause
goto END

:SHOW_USAGE
echo usage:
echo   mkDCExpertRestoreUsbKey.bat [ISO File]
pause
goto END

:END
